"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _getPreviewDataToImport = _interopRequireDefault(require("../../helpers/getPreviewDataToImport"));

var _ = _interopRequireDefault(require(".."));

var _Column = _interopRequireDefault(require("../../../Column"));

jest.mock('../../helpers/getPreviewDataToImport', function () {
  return jest.fn();
});
var props = {
  schemaFields: ['name', 'email'],
  data: [{
    Name: 'John',
    Email: 'john@gmail.com'
  }, {
    Name: 'Marie',
    Email: 'marie@gmail.com'
  }],
  fieldsMap: {
    name: 'Name',
    email: 'Email'
  },
  attributes: {
    name: {
      required: true
    },
    email: {}
  }
};
describe('<StepFour />', function () {
  it('should call getPreviewDataToImport with the right values', function () {
    (0, _enzyme.mount)(_react["default"].createElement(_["default"], props));
    var data = [{
      Name: 'John',
      Email: 'john@gmail.com'
    }, {
      Name: 'Marie',
      Email: 'marie@gmail.com'
    }];
    var fieldsMap = {
      name: 'Name',
      email: 'Email'
    };
    var attributes = {
      name: {
        required: true
      },
      email: {}
    };
    expect(_getPreviewDataToImport["default"]).toHaveBeenCalledWith(data, fieldsMap, attributes);
  });
  it('should render the right amount of columns', function () {
    var component = (0, _enzyme.shallow)(_react["default"].createElement(_["default"], props));
    expect(component.find(_Column["default"]).length).toBe(2);
  });
});