"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _modifyCell = _interopRequireDefault(require("../modifyCell"));

var _assignButton = _interopRequireDefault(require("../styled/assignButton"));

describe('<ModifyCell />', function () {
  it('should have proper labels according to value status', function () {
    expect.assertions(2);
    var component = (0, _enzyme.mount)(_react["default"].createElement(_modifyCell["default"], {
      row: {
        databaseField: 'name'
      }
    }));
    expect(component.text()).toBe('Assign');
    component.setProps({
      value: 'test'
    });
    expect(component.text()).toBe('Change');
  });
  it('should trigger click event using database param', function () {
    var onClickFn = jest.fn();
    var row = {
      databaseField: 'name'
    };
    var component = (0, _enzyme.mount)(_react["default"].createElement(_modifyCell["default"], {
      onClick: onClickFn,
      row: row
    }));
    component.find(_assignButton["default"]).simulate('click');
    expect(onClickFn).toHaveBeenCalledWith(row.databaseField);
  });
});