import React from 'react';
import PropTypes from 'prop-types';
import { hexToRgba } from '../../styles/helpers/color';
import { StyledColorSample } from './styled';

var ColorSample = function ColorSample(_ref) {
  var value = _ref.value;
  var backgroundColor = value ? hexToRgba(value.hex, value.alpha) : undefined;
  return React.createElement(StyledColorSample, {
    backgroundColor: backgroundColor
  });
};

ColorSample.propTypes = {
  value: PropTypes.shape({
    hex: PropTypes.string,
    alpha: PropTypes.number
  })
};
ColorSample.defaultProps = {
  value: undefined
};
export default ColorSample;