import React from 'react';
import { mount, shallow } from 'enzyme';
import getPreviewDataToImport from '../../helpers/getPreviewDataToImport';
import StepFour from '..';
import Column from '../../../Column';
jest.mock('../../helpers/getPreviewDataToImport', function () {
  return jest.fn();
});
var props = {
  schemaFields: ['name', 'email'],
  data: [{
    Name: 'John',
    Email: 'john@gmail.com'
  }, {
    Name: 'Marie',
    Email: 'marie@gmail.com'
  }],
  fieldsMap: {
    name: 'Name',
    email: 'Email'
  },
  attributes: {
    name: {
      required: true
    },
    email: {}
  }
};
describe('<StepFour />', function () {
  it('should call getPreviewDataToImport with the right values', function () {
    mount(React.createElement(StepFour, props));
    var data = [{
      Name: 'John',
      Email: 'john@gmail.com'
    }, {
      Name: 'Marie',
      Email: 'marie@gmail.com'
    }];
    var fieldsMap = {
      name: 'Name',
      email: 'Email'
    };
    var attributes = {
      name: {
        required: true
      },
      email: {}
    };
    expect(getPreviewDataToImport).toHaveBeenCalledWith(data, fieldsMap, attributes);
  });
  it('should render the right amount of columns', function () {
    var component = shallow(React.createElement(StepFour, props));
    expect(component.find(Column).length).toBe(2);
  });
});