import React from 'react';
import { mount } from 'enzyme';
import ModifyCell from '../modifyCell';
import StyledAssignButton from '../styled/assignButton';
describe('<ModifyCell />', function () {
  it('should have proper labels according to value status', function () {
    expect.assertions(2);
    var component = mount(React.createElement(ModifyCell, {
      row: {
        databaseField: 'name'
      }
    }));
    expect(component.text()).toBe('Assign');
    component.setProps({
      value: 'test'
    });
    expect(component.text()).toBe('Change');
  });
  it('should trigger click event using database param', function () {
    var onClickFn = jest.fn();
    var row = {
      databaseField: 'name'
    };
    var component = mount(React.createElement(ModifyCell, {
      onClick: onClickFn,
      row: row
    }));
    component.find(StyledAssignButton).simulate('click');
    expect(onClickFn).toHaveBeenCalledWith(row.databaseField);
  });
});