import React from 'react';
import PropTypes from 'prop-types';
import Button from '../../Button';
import StyledFooter from './styled/footer';
import StyledCancelButton from './styled/cancelButton';
export default function AssignFieldModalFooter(props) {
  var onCancel = props.onCancel,
      onAssign = props.onAssign,
      isAssignButtonDisabled = props.isAssignButtonDisabled;
  return React.createElement(StyledFooter, null, React.createElement(StyledCancelButton, {
    label: "Cancel",
    onClick: onCancel
  }), React.createElement(Button, {
    label: "Assign",
    variant: "brand",
    onClick: onAssign,
    disabled: isAssignButtonDisabled
  }));
}
AssignFieldModalFooter.propTypes = {
  onCancel: PropTypes.func,
  onAssign: PropTypes.func,
  isAssignButtonDisabled: PropTypes.bool
};
AssignFieldModalFooter.defaultProps = {
  onCancel: function onCancel() {},
  onAssign: function onAssign() {},
  isAssignButtonDisabled: false
};